#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "resource.h"

#define G 9.81			//Fallbeschleunigung der Erde
#define STEP .000000001 //Zeitschritte


LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

int Vx=26; //Geschwindigkeit horizontal
int Vy=26; //      "         vertikal

double x=0; double y=0; //Position Krper
double t=0; //Zeit
double s=0; //Weg

char schrift[200];

BOOL CALLBACK DialogProcSettings(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	const char name[]="schiefer Wurf";

	HWND hWnd;
	MSG msg;
	WNDCLASS wc;

	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.hIcon=LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance=hInstance;
	wc.lpfnWndProc=WndProc;
	wc.lpszClassName=name;
	wc.lpszMenuName="menu";
	wc.style=CS_HREDRAW | CS_VREDRAW;

	RegisterClass(&wc);

	hWnd=CreateWindow(name, name, WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), NULL, NULL, hInstance, NULL);

	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
};

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	static HINSTANCE hInstance;
	RECT rect;

	if((message==WM_CREATE)||(message==WM_RBUTTONDOWN))
	{
		InvalidateRect(hWnd, 0,1);
	}

	if (message==WM_DESTROY)
	{
		PostQuitMessage(0);
		return 0;
	}


	if (message==WM_PAINT)
	{		
		GetClientRect(hWnd, &rect);
		x=0; y=rect.bottom; t=0;  //Variablen zurcksetzen

		hdc=BeginPaint(hWnd, &ps);
		while((y<=rect.bottom)&&(x<rect.right))
		{//solange innerhalb des sichtbaren Bereiches
			t+=STEP; //Zeit erhhen
			
			s=Vx*t;  //vertikale Geschwindigkeit berechnen
			x+=s;

			s=Vy*t;  //horizontale Geschwindigkeit berechnen
			y-=s;


			s=((G)/2)*(pow(t*100,2)); //Fallbeschleunigung berechnen
			y+=s;
	
			SetPixel(hdc, (int)x, (int)y, RGB(0,0,0)); //"Krper" darstellen
		} 
		EndPaint(hWnd, &ps);

		return 0;
	}

	if(message==WM_COMMAND) //Men
	{
		switch(LOWORD(wParam))
		{
		case(beenden): //Wenn Beenden gedrckt: Sende Nachricht "WM_DESTROY"
			SendMessage(hWnd, WM_DESTROY, 0,0);
			break;
		case(settings):
			DialogBox(hInstance, "IDD_SETTINGS", hWnd, DialogProcSettings);
			InvalidateRect(hWnd, 0, 1);
			break;
		}
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
};


BOOL CALLBACK DialogProcSettings(HWND hDlgSettings, UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message==WM_INITDIALOG)
	{
		wsprintf(schrift, "%i", Vx);
		SetDlgItemText(hDlgSettings, ID_VX, schrift);
		
		wsprintf(schrift, "%i", Vy);
		SetDlgItemText(hDlgSettings, ID_VY, schrift);

		SetFocus(GetDlgItem(hDlgSettings, ID_VX));
	}

	if(message==WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case(IDOK):
			GetDlgItemText(hDlgSettings, ID_VX, schrift, sizeof(schrift));
			Vx=(atoi(schrift));

			GetDlgItemText(hDlgSettings, ID_VY, schrift, sizeof(schrift));
			Vy=(atoi(schrift));
		case(IDCANCEL):
			EndDialog(hDlgSettings, 0);
			break;
		}
	}

	return FALSE;
}
